<template>
  <div class="w-full game-filter-style-one sticky top-[52px] z-[21]">
    <div
      class="flex justify-between p-2 w-full items-center filter-top-part ol-bg-light-2 border-b-[1px] border-[var(--border)] l-1350"
    >
      <div class="flex gap-2 items-center">
        <span class="bg-5 rounded-xl p-1.5">
          <component
            :is="getComponent(groupTitle)"
            v-if="getComponent(groupTitle)"
            class="h-3 w-3 group-title-label"
          />
          <ProviderIcon v-else class="h-3 w-3" />
        </span>
        <span
          v-if="['Game Type', 'Provider'].includes(selectingCategory.type)"
          class="text-sm font-medium --text4"
        >
          {{ $t(selectingCategory.label) }}
        </span>
        <span v-else class="text-sm font-medium --text4">
          {{
            $t(
              selectingCategory.label
                .replace("All Games", "All")
                .toLowerCase()
                .replace(" ", "_")
            )
          }}
        </span>
      </div>
      <button
        class="bg-5 border-[2px] border-[var(--border)] px-4 rounded-lg h-10"
        :class="{
          'bg-primary': drawer,
        }"
        @click="drawer = true"
      >
        <div class="flex gap-2 items-center">
          <div class="flex gap-1 items-center justify-center">
            <span
              class="bg-primary w-1 h-1 rounded-full"
              :class="{
                '!bg-[var(--textBtn)]': drawer,
              }"
            ></span>
            <span class="text-sm font-normal --text4 uppercase">
              {{ $t("filter") }}
            </span>
          </div>
          <FilterIcon class="w-4 h-4" />
        </div>
      </button>
    </div>
  </div>
  <div class="game-filter-style-one">
    <el-drawer
      v-model="drawer"
      direction="btt"
      modal-class="filter-bottom-sheet"
      size="87%"
    >
      <template #header>
        <div class="flex gap-1 items-center">
          <span class="bg-primary w-1 h-1 rounded-full"></span>
          <span class="text-sm font-normal --text4 uppercase">{{
            $t("filter")
          }}</span>
        </div>
      </template>
      <template v-for="(section, index) in filterSection" :key="section">
        <div class="--text4 text-sm font-medium uppercase my-2 px-2">
          {{ $t(section) }}
        </div>
        <div
          class="flex gap-2 flex-wrap pb-2 border-[var(--border)] px-2"
          :class="{
            'border-b-[1px]': index < filterSection.length - 1,
          }"
        >
          <template
            v-for="(item, idx) in gameMenuForDisplay"
            :key="`item-${idx}`"
          >
            <template
              v-for="menu in filterSpecificMenu(item.Menus, section)"
              :key="`menu-${menu.Label}`"
            >
              <template v-if="section === 'main'">
                <div
                  class="flex gap-1 px-3 py-2 bg-5 rounded-lg justify-center items-center h-10"
                  :class="{
                    'activeButton ol-bg-dark-2 fc-primary': menu.IsActive,
                  }"
                  @click="onGameTabClicked(menu)"
                >
                  <component :is="getComponent(menu.Label)" class="w-4 h-4" />
                  <span class="text-xs uppercase --text4 leading-[normal]">{{
                    $t(
                      menu.Label.replace("All Games", "All")
                        .toLowerCase()
                        .replace(" ", "_")
                    )
                  }}</span>
                </div>
              </template>
              <template v-else>
                <div
                  v-for="(dropdown, index) in menu.DropDownMenus"
                  :key="`dropdown-${index}`"
                  class="flex gap-1 px-3 py-2 bg-5 rounded-lg justify-center items-center h-10"
                  :class="{
                    'activeButton ol-bg-dark-2 fc-primary': dropdown.IsActive,
                  }"
                  @click="onDropDownItemClicked(dropdown)"
                >
                  <component
                    :is="getComponent(dropdown.DropDownLabel)"
                    class="w-4 h-4"
                  />
                  <template v-if="section === 'game_type'">
                    <span class="text-xs uppercase --text4 leading-[normal]">
                      {{ $t(String(dropdown.DropDownLabel)) }}
                    </span>
                  </template>
                  <span
                    v-else
                    class="text-xs uppercase --text4 leading-[normal]"
                  >
                    {{ $t(dropdown.GameProviderDisplayName) }}
                  </span>
                </div>
              </template>
            </template>
          </template>
        </div>
      </template>
      <div class="w-full h-14"></div>
      <div
        class="apply-filter-button bg-5 w-full fixed bottom-0 p-2 flex"
        @click="onClickApplyFilter"
      >
        <span
          class="p-3 bg-primary rounded-lg w-full text-center text-sm font-medium --textBtn leading-[normal] h-10"
        >
          {{ $t("apply") }}
        </span>
      </div>
    </el-drawer>
    <div class="w-full flex border-b-[1px] border-[var(--border)]">
      <el-input
        v-model="searchModel"
        class="game-search-input"
        :placeholder="`${$t('search_games')}...`"
        @input="searching"
      >
        <template #prefix>
          <Search />
        </template>
      </el-input>
      <span
        class="flex items-center bg-primary px-4 py-3 --textBtn text-sm font-medium whitespace-nowrap"
        :class="{
          'pointer-events-none': !searchModel,
        }"
        @click="handleGameSearch"
      >
        {{ $t("search") }}
      </span>
    </div>
  </div>
</template>
<script lang="ts">
import { Search } from "@element-plus/icons-vue";
import { defineComponent, onMounted, PropType, Ref, ref } from "vue";
import {
  GameEntryMenu,
  IGameEntryMenu,
  TabGameDropDownMenus,
  TabGameMenu,
} from "@/models/gameEntryFilter";
import { GameFilterRequest } from "@/models/bsiGameList";
import commonHelper from "@/utils/commonHelper";
import SlotIcon from "@/assets/icons/game-type/slot-icon.svg?component";
import FilterIcon from "@/assets/icons/filter-icon.svg?component";
import AllIcon from "@/assets/icons/game-filter/all.svg?component";
import HotGameIcon from "@/assets/icons/game-filter/hot_games.svg?component";
import FavoriteIcon from "@/assets/icons/game-filter/favorite.svg?component";
import NewGameIcon from "@/assets/icons/game-filter/new_games.svg?component";
import SpecialSelectionIcon from "@/assets/icons/game-filter/special_selection.svg?component";
import ArcadeGameIcon from "@/assets/icons/game-filter/ArcadeGames.svg?component";
import FishingGamesIcon from "@/assets/icons/game-filter/FishingGames.svg?component";
import LotteryGamesIcon from "@/assets/icons/game-filter/LotteryGames.svg?component";
import OthersGamesIcon from "@/assets/icons/game-filter/OthersGames.svg?component";
import ScratchcardsIcon from "@/assets/icons/game-filter/Scratchcards.svg?component";
import SlotsIcon from "@/assets/icons/game-filter/Slots.svg?component";
import TableGamesIcon from "@/assets/icons/game-filter/TableGames.svg?component";
import VirtualGamesIcon from "@/assets/icons/game-filter/VirtualGames.svg?component";
import ProviderIcon from "@/assets/icons/game-filter/ProviderIcon.svg?component";

export default defineComponent({
  name: "GameEntryFilter",
  components: {
    SlotIcon,
    Search,
    FilterIcon,
    AllIcon,
    NewGameIcon,
    HotGameIcon,
    FavoriteIcon,
    SpecialSelectionIcon,
    ArcadeGameIcon,
    FishingGamesIcon,
    LotteryGamesIcon,
    OthersGamesIcon,
    ScratchcardsIcon,
    SlotsIcon,
    TableGamesIcon,
    VirtualGamesIcon,
    ProviderIcon,
  },
  props: {
    menus: {
      type: Array as PropType<IGameEntryMenu[]>,
      default: () => [],
    },
    search: {
      type: String,
      default: "",
    },
    isVerticalTabContent: {
      type: Boolean,
      default: false,
    },
    activeColor: {
      type: String,
      default: "text-primary",
    },
    groupTitle: {
      type: String,
      default: "",
    },
  },
  emits: ["onFilterClicked", "update:search", "searchGames"],
  setup(props, { emit }) {
    const route = useRoute();
    const router = useRouter();

    const { getAssetImage } = commonHelper;

    const gameMenuForDisplay: Ref<GameEntryMenu[]> = ref<GameEntryMenu[]>(
      props.menus.map(
        (item) => new GameEntryMenu(item, route.query.f === undefined)
      )
    );
    const sharedRequest = ref<GameFilterRequest>();
    const searchModel = ref(props.search);

    const drawer = ref(false);
    const selecting = ref<TabGameDropDownMenus | TabGameMenu>();
    const selectingCategory = ref({
      label: "",
      type: "",
    });

    const filterSection = ["main", "game_type", "provider"];
    const tabIcons: Record<string, Component> = {
      all: AllIcon,
      newgames: NewGameIcon,
      hotgames: HotGameIcon,
      favorite: FavoriteIcon,
      specialselection: SpecialSelectionIcon,
      arcadegames: ArcadeGameIcon,
      fishinggames: FishingGamesIcon,
      lotterygames: LotteryGamesIcon,
      othersgames: OthersGamesIcon,
      scratchcards: ScratchcardsIcon,
      slots: SlotsIcon,
      tablegames: TableGamesIcon,
      virtualgames: VirtualGamesIcon,
    };

    const toggleActive = (param: TabGameDropDownMenus | TabGameMenu) => {
      gameMenuForDisplay.value.forEach((menus) => {
        menus.Menus.forEach((menu) => {
          menu.IsActive = menu === param;
          if (menu === param) {
            selectingCategory.value = {
              label: menu.Label,
              type: menu.Label,
            };
            selecting.value = menu;
            sharedRequest.value = {
              Type: menu.Label,
              Value: menu.Label,
            };
          }
          menu.DropDownMenus.forEach((menuItem) => {
            menuItem.IsActive = menuItem === param;
            if (menuItem === param) {
              selectingCategory.value = {
                label: menuItem.GameProviderDisplayName,
                type: menu.Label,
              };
              selecting.value = menuItem;
              sharedRequest.value = {
                Type: menu.Label,
                Value: menuItem.DropDownLabel,
              };
            }
          });
        });
      });
    };

    const onDropDownItemClicked = (param: TabGameDropDownMenus) => {
      toggleActive(param);
      selecting.value = param;
      searchModel.value = "";
    };

    const onGameTabClicked = (param: TabGameMenu) => {
      toggleActive(param);
      searchModel.value = "";
      selecting.value = param;
    };

    const searching = (e: any) => {
      if (!e) {
        handleGameSearch();
      }
      emit("update:search", searchModel.value);
    };

    const handleGameSearch = () => {
      if (!searchModel.value) {
        emit("onFilterClicked", sharedRequest.value);
      }
      emit("searchGames");
    };

    const checkActive = (filterQuery: any) => {
      gameMenuForDisplay.value.forEach((menus) => {
        menus.Menus.forEach((menu) => {
          if (route.params.filter) {
            menu.DropDownMenus.forEach((item) => {
              if (route.params.filter === item.DropDownLabel) {
                toggleActive(item);
                emit("onFilterClicked", sharedRequest.value);
              }
            });
            return;
          }
          if (menu.Label.toLowerCase() !== filterQuery.toLowerCase()) return;
          toggleActive(menu);
          emit("onFilterClicked", sharedRequest.value);
        });
      });
    };

    onMounted(() => {
      const filterQuery = route.query.f;
      checkActive(filterQuery);
    });

    const filterSpecificMenu = (menus: TabGameMenu[], section: string) => {
      if (section === "main")
        return menus.filter(
          (item) => !["Provider", "Game Type"].includes(item.Label)
        );
      if (section === "game_type")
        return menus.filter((item) => item.Label.includes("Game Type"));
      return menus.filter((item) => item.Label.includes("Provider"));
    };

    const onClickApplyFilter = () => {
      if (selecting.value instanceof TabGameMenu)
        router.replace(`/games/?f=${selecting.value.Label}`);
      if (selecting.value instanceof TabGameDropDownMenus)
        router.replace(`/games/${selecting.value.DropDownLabel}`);
      emit("onFilterClicked", sharedRequest.value);
      emit("update:search", "");
      drawer.value = false;
    };

    const getComponent = (componentName: string) =>
      tabIcons?.[
        componentName.replace("All Games", "All").toLowerCase().replace(" ", "")
      ] ?? undefined;

    return {
      gameMenuForDisplay,
      searching,
      searchModel,
      onDropDownItemClicked,
      onGameTabClicked,
      getAssetImage,
      handleGameSearch,
      drawer,
      filterSpecificMenu,
      filterSection,
      onClickApplyFilter,
      tabIcons,
      getComponent,
      selectingCategory,
      selecting,
    };
  },
});
</script>
<style lang="scss">
.game-filter-style-one {
  .game-search-input {
    --el-input-text-color: var(--text1);
    --el-input-icon-color: var(--text1);

    .el-input__inner {
      background: transparent;
    }
  }

  .filter-top-part {
    --bg-base-color: var(--background5);
    --bg-opacity: 0.35;
  }
  .apply-filter-button {
    --bg-base-color: var(--background5);
    --bg-opacity: 0.05;
  }
  .group-title-label {
    path {
      fill: var(--primary);
    }
  }
  .el-input {
    .el-input__inner {
      border-radius: unset !important;
      border: none;
      --el-input-hover-border-color: transparent;
      --el-input-border-color: transparent;
      &::placeholder {
        padding-left: 10px;
      }
    }
    .el-input__prefix-inner {
      display: flex;
      align-items: center;
      svg {
        @apply w-4 h-4;
      }
    }
  }
  .filter-bottom-sheet {
    .el-drawer {
      border-radius: 8px 8px 0px 0px;
      .el-drawer__header {
        @apply px-4 py-3 mb-0 h-10;

        border-bottom: 1px solid var(--border);
        background: linear-gradient(
            0deg,
            rgba(23, 23, 23, 0.05),
            rgba(23, 23, 23, 0.05)
          ),
          linear-gradient(0deg, var(--background5), var(--background5)) !important;
      }
      .el-drawer__body {
        @apply px-0 py-0;
      }
      .activeButton {
        border: 2px solid var(--primary);
        --bg-base-color: var(--background5);
        --bg-opacity: 0.35;
        span {
          color: var(--primary) !important;
        }
      }
    }
  }
}
</style>
